Imports System.Runtime.InteropServices
Imports System.Windows.Forms

'Add-in Express Excel Add-in Module
<GuidAttribute("F2521985-FDC1-41E3-A3F9-34D1C8830976"), _
ProgIdAttribute("ExcelFormula.ExcelAddinModule1"), ClassInterface(ClassInterfaceType.AutoDual)> _
Public Class ExcelAddinModule1
    Inherits AddinExpress.MSO.ADXExcelAddinModule
 
#Region " ADX automatic code "
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXExcelAddinModule.ADXExcelAddinRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXExcelAddinModule.ADXExcelAddinUnregister(t)
    End Sub
 
#End Region
 
    'Excel Add-in Module Implementation
 
    Public Sub New()
        MyBase.New()
 
    End Sub


    Public Function MyFunc(ByVal Range As Object) As Object
        Dim xlRange As Excel.Range = Nothing
        Dim retVal As String
        Dim row As Integer
        Dim col As Integer

        Try
            xlRange = CType(Range, Excel.Range)
            If Not (xlRange Is Nothing) Then
                row = xlRange.Row
                col = xlRange.Column
                retVal = "The range address is: [" + _
                    xlRange.Address(row, col, Excel.XlReferenceStyle.xlA1, Nothing, Nothing) + "]"
                retVal = retVal.Replace("$", String.Empty)
            End If
        Catch err As Exception
            Return New ErrorWrapper(err)
        Finally
            If Not (Range Is Nothing) Then
                Marshal.ReleaseComObject(Range)
            End If
        End Try
        Return retVal
    End Function

End Class

